package cn.com.ty.lift.business.emergency.dto;

import cn.com.ty.lift.business.emergency.entity.EmergencyRepair;
import cn.hutool.core.date.BetweenFormater;
import cn.hutool.core.date.DateUtil;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * @author wcz
 * @date 2019/12/6
 * @description
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class RepairResponse extends EmergencyRepair{

    /**
     * 区域名称
     */
    private String areaName;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 电梯注册代码
     */
    private String registrationCode;

    /**
     * 电梯位置
     */
    private String devicePosition;

    /**
     * 报修人姓名
     */
    private String callName;

    /**
     * 维修工
     */
    private String workerName;

    /**
     * 创建人(召修人)
     */
    private String createName;
    /**
     * 电梯公司状态
     */
    private Integer liftCompanyStatus;

    /**
     * 维修时长秒数
     */
    private long repairDiff;

    private String repairDuration;

    /**
     * 重新getter方法，换算时长
     * XX天XX小时XX分XX秒
     * @return
     */
    public String getRepairDuration() {
        return DateUtil.formatBetween(this.repairDiff, BetweenFormater.Level.SECOND);
    }
}
